<?php if (!defined('APPLICATION')) exit();
$PluginInfo['Replacer'] = array(
   'Description' => 'Activate once to change links from "http://forums.example.com/798-hi/#post4061" to "http://forums.example.com/discussion/798/hi/#Comment_4061"'
);

class Replacer extends Gdn_Plugin {
   
   public function NewBody($OldBody) {
      $Result = preg_replace("/(forums\.example\.com\/)(\d+)-(.*)(\/#post)(\d+)/", "$1discussion/$2/$3/#Comment_$5", $OldBody);
      return $Result;
   }
   public function PluginController_Replacer_Create($Sender) {

      $Sql = Gdn::SQL();
      $DiscussionModel = new DiscussionModel();
      $CommentModel = new CommentModel();
      $ConversationMessageModel = new ConversationMessageModel();

      $Discussions = $DiscussionModel->Get();
      foreach($Discussions as $Discussion) {
         $DiscussionID = $Discussion->DiscussionID;

         $Body = $this->NewBody($Discussion->Body);
         decho('D: '.$Body);
         echo('<hr>');
         $Sql->Update('Discussion')
            ->Set('Body', $Body)
            ->Where('DiscussionID', $DiscussionID)
            ->Put();

         $Comments = $CommentModel->Get($Discussion->DiscussionID);
         foreach($Comments as $Comment) {
            $CommentID = $Comment->CommentID;
            $Body = $this->NewBody($Comment->Body);
            decho('C: '.$Body);
            echo('<hr>');
            $Sql->Update('Comment')
               ->Set('Body', $Body)
               ->Where('CommentID', $CommentID)
               ->Put();
         }
      }
   }
}